#!/usr/bin/env python
# -*- coding:utf-8 -*-

# Program: 客户下订单
# Author : HH
# Date   : 2016-02-08

import sys
import mysql.connector
import json
import snowflake.client

reload(sys)
sys.setdefaultencoding('utf-8')

if __name__ == '__main__':
  '''
  这边模拟用户：username77购买 store2 中的 goods27和goods69商品
  '''
  # 设置公共库连接配置
  db_config_common = {
    'user'    : 'root',
    'password': 'root',
    'host'    : '127.0.0.1',
    'port'    : 3306,
    'database': 'test'
  }
  # 设置snowflake链接默认参数
  snowflake_config = {
    'host': '192.168.137.11',
    'port': 30001
  }
  # 配置snowflake
  snowflake.client.setup(**snowflake_config)
  # 获得公共数据库的链接和游标
  conn_common = mysql.connector.connect(**db_config_common)
  cursor_select_common = conn_common.cursor(buffered=True)
  cursor_dml_common = conn_common.cursor(buffered=True)
  # 获得用户:username77的基本信息
  select_sql = '''
    SELECT u.user_id,
      u.table_flag,
      u.db_name,
      ss.value
    FROM user AS u
      LEFT JOIN system_setting AS ss ON u.db_name = ss.name
    WHERE username = 'username77'
  '''
  cursor_select_common.execute(select_sql)
  buy_user_id, buy_table_flag, buy_db_name, buy_db_config_json \
    = cursor_select_common.fetchone()
  # 获得购买者的链接和游标
  conn_buy = mysql.connector.connect(**json.loads(buy_db_config_json))
  cursor_select_buy = conn_buy.cursor(buffered=True)
  cursor_dml_buy = conn_buy.cursor(buffered=True)
  # 通过店铺名称获得导购以及导购所对应的用户所使用的数据库链接描述符
  select_sql = '''
    SELECT s.user_id,
      ug.user_guide_id,
      u.table_flag,
      u.db_name,
      ss.value AS db_config_json
    FROM store AS s
      LEFT JOIN user AS u USING(user_id)
      LEFT JOIN user_guide AS ug USING(user_id)
      LEFT JOIN system_setting AS ss ON ss.name = u.db_name
    WHERE s.user_id = 2
  '''
  cursor_select_common.execute(select_sql)
  sell_user_id, user_guide_id, sell_table_flag, sell_dbname, \
  sell_db_config_json = cursor_select_common.fetchone()
  
  # 获得出售者的数据库链接描述符以及游标
  conn_sell = mysql.connector.connect(**json.loads(sell_db_config_json))
  cursor_select_sell = conn_sell.cursor(buffered=True)
  cursor_dml_sell = conn_sell.cursor(buffered=True)
  # 成订单ID
  order_id = snowflake.client.get_guid()
  # 获得商品信息并生成商品订单信息。
  select_goods_sql = '''
    SELECT goods_id,
      price
    FROM {goods_table}
    WHERE goods_id IN(3794292584748158977, 3794292585729626113)
  '''.format(goods_table = 'goods_' + str(sell_table_flag))
  cursor_select_sell.execute(select_goods_sql)
  # 订单价格
  order_price = 0
  for goods_id, price in cursor_select_sell:
    order_price += price
    # 生成订单商品信息
    insert_order_goods_sql = '''
      INSERT INTO {table_name}
      VALUES({guid}, {order_id}, {goods_id}, {user_guide_id},
        {price}, 1)
    '''.format(table_name = 'order_goods_' + str(sell_table_flag),
               guid = snowflake.client.get_guid(),
               order_id = order_id,
               goods_id = goods_id,
               user_guide_id = user_guide_id,
               price = price)
    cursor_dml_sell.execute(insert_order_goods_sql)
  # 生成订单记录
  insert_order_sql = '''
    INSERT INTO {order_table}
    VALUES({order_id}, {user_guide_id}, {user_id}, 
      {price}, 0)
  '''.format(order_table = 'sell_order_' + str(sell_table_flag),
             order_id = order_id,
             user_guide_id = user_guide_id,
             user_id = buy_user_id,
             price = order_price)
  cursor_dml_sell.execute(insert_order_sql)
  # 生成购买者订单记录
  insert_order_sql = '''
    INSERT INTO {order_buy_table}
    VALUES({order_id}, {user_id}, {user_guide_id})
  '''.format(order_buy_table = 'buy_order_' + str(buy_table_flag),
             order_id = order_id,
             user_id = buy_user_id,
             user_guide_id = user_guide_id)
  cursor_dml_buy.execute(insert_order_sql)

  # 提交事物
  conn_buy.commit()
  conn_sell.commit()
  # 关闭有标链接
  cursor_select_common.close()
  cursor_select_buy.close()
  cursor_select_sell.close()
  cursor_dml_common.close()
  cursor_dml_buy.close()
  cursor_dml_sell.close()

  conn_common.close()
  conn_buy.close()
  conn_sell.close()
